CGAL 6.2 - Linear Cell Complex: CGAL::Linear_cell_complex_for_generalized_map< d, d2, LCCTraits, Items, Alloc > Class Template Reference

CGAL 6.2 - Linear Cell Complex

Loading...
Searching...
No Matches
List of all members
CGAL::Linear_cell_complex_for_generalized_map< d, d2, LCCTraits, Items, Alloc > Class Template Reference
Reference Manual » Classes

`#include <CGAL/Linear_cell_complex_for_generalized_map.h>`

## Inherits from

CGAL::Generalized_map< d, Items, Alloc >.

## Definition

template<typename d, typename d2, typename LCCTraits, typename Items, typename Alloc>
class CGAL::Linear_cell_complex_for_generalized_map< d, d2, LCCTraits, Items, Alloc >

The class `Linear_cell_complex_for_generalized_map` represents a linear cell complex in dimension `d`, in an ambient space of dimension `d2`, using a generalized map as underlying combinatorial data-structure.

Like for `GeneralizedMap`, two versions exist: one where Darts and non void attributes are stored in memory using `Compact_container`, using `Alloc` as allocator, and use handles as descriptors; a second one where Darts and non void attributes are stored in an internal std::vector like data-structure, and use indices as descriptors. The choice between the two versions is done through the item class.

Is model of
  `LinearCellComplex`
  `GeneralizedMap`

Template Parameters

  d | the dimension of the generalized map.
  d2 | the dimension of the ambient space. Equal to `d` by default.
  LCCTraits | a model of the `LinearCellComplexTraits` concept, satisfying `LCCTraits::ambient_dimension``==d2`. Equal to`CGAL::Linear_cell_complex_traits<d2>` by default.
  Items | a model of the `LinearCellComplexItems` concept. Equal to `CGAL::Linear_cell_complex_min_items<d>` by default.
  Alloc | has to match the standard allocator requirements. Equal to `CGAL_ALLOCATOR(int)` by default.

Advanced

Note that there is an additional, and undocumented, template parameter `GMap` for `Linear_cell_complex_for_generalized_map<d,d2,LCCTraits,Items,Alloc,GMap>` allowing to inherit from any model of the `GeneralizedMap` concept.

See also
  `CGAL::Generalized_map<d,Items,Alloc>`
  `CGAL::Linear_cell_complex_traits<d,K>`
  `CGAL::Linear_cell_complex_min_items<d>`

Examples
  Linear_cell_complex/linear_cell_complex_3_insert.cpp, and Linear_cell_complex/linear_cell_complex_4.cpp.

## Constants
static unsigned int | ambient_dimension = d2
| Ambient dimension, must be > 1.

## Additional Inherited Members
Public Types inherited from CGAL::Generalized_map< d, Items, Alloc >
typedef Generalized_map< d, Items, Alloc > | Self
typedef Items::Dart_wrapper< Self >::Dart_info | Dart_info
typedef Items::Dart_wrapper< Self >::Attributes | Attributes
Static Public Attributes inherited from CGAL::Generalized_map< d, Items, Alloc >
static const unsigned int | dimension